import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author austin young
 * @version 12.13.2019
 */
public class Ball extends Actor
{
    private int bounceY = 0;
    private int bounceX = 3;
    private int speedX = 3;
    private int speedY = 3;


    public void act() 
    {
        checkWall1();
        checkWall2();
        checkHit1();
        checkHit2();
        checkWin1();
        checkWin2();
        move();
    }   
    
    /**
     * When the ball makes contact with the wall, the player 2 wins
     */
    public boolean hitWin2()
    {
        Actor theBall = getOneObjectAtOffset (0, 0, Win2.class);
        return theBall != null;
    }
    
    /**
     * When the ball makes contact with the wall, the player 1 wins
     */
    public boolean hitWin1()
    {
        Actor theBall = getOneObjectAtOffset (0, 0, Win1.class);
        return theBall != null;
    }
    
     /**
     * Bounces off the wall
     */
    public boolean hitWall1()
    {
        Actor theBall = getOneObjectAtOffset (0, 0, Wall1.class);
        return theBall != null;
    }
    
     /**
     * Bounces off the wall
     */
    public boolean hitWall2()
    {
        Actor theBall = getOneObjectAtOffset (0, 0, Wall2.class);
        return theBall != null;
    }
    
     /**
     * Bounces off the paddle
     */
    public boolean hitBat1()
    {
        Actor theBall = getOneObjectAtOffset (0, 0, Bat1.class);
        return theBall != null;
    }
    
     /**
     * Bounces off the paddle
     */
    public boolean hitBat2()
    {
        Actor theBall = getOneObjectAtOffset (0, 0, Bat2.class);
        return theBall != null;
    }
    
     /**
     * Ball location and speed
     */
    public void move()
    {
        setLocation (getX() + speedX,getY() + speedY);
    }
    
    /**
     * Checks if the player won, if so, image is shown and sound is played
     */
    public void checkWin1()
    {
        if (hitWin1())
        {
            setImage("p2w.jpg");
            setLocation (300,200);
            Greenfoot.playSound("win.wav");
        {
            Greenfoot.stop();
        }
    }
    }
    
    /**
     * Checks if the player won, if so, image is shown and sound is played
     */
    public void checkWin2()
    {
        if (hitWin2())
        {
            setImage("p1w.jpg");
            setLocation (300,200);
            Greenfoot.playSound("win.wav");
        {
            Greenfoot.stop();
        }
        }
    }
    
     /**
     * When the ball makes contact with the wall, the player 1 wins
     */
    public void checkWall1()
    {
        if (hitWall1())
        {
            speedY = speedY - speedY - speedY;
            Greenfoot.playSound("beep.wav");
        }
    }
        
     /**
     * When the ball makes contact with the wall, the player 1 wins
     */
            public void checkWall2()
    {
        if (hitWall2())
        {
            speedY = speedY - speedY - speedY;
            Greenfoot.playSound("beep.wav");
        }
    }
    
     /**
     * When the ball makes contact with the wall, the player 1 wins
     */
    public void checkHit2()
    {
        if(hitBat2())
        {
            speedX = speedX + 0;
            speedX = speedX - speedX - speedX;
            Greenfoot.playSound("switch.wav");
        }
    }
    
     /**
     * When the ball makes contact with the wall, the player 1 wins
     */
    public void checkHit1()
        {
        if(hitBat1())
        {
            speedX = speedX + 1;
            speedX = speedX - speedX - speedX;
            Greenfoot.playSound("switch.wav");
        }
    }
    
    public void changeDirection()
    {
        speedX = speedX - speedX - speedX;
    }
}
